//
//  GBPrefsTabController.h
//  gBrowser
//
//  Created by Andreas Schwarz on Wed Mar 13 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GBPrefsData;
@class GBAppPrefsData;

@interface GBPrefsTabController : NSObject {
    IBOutlet NSTabViewItem *tabViewItem;
    IBOutlet id parent;
    
    id prefsDelegate;
	GBAppPrefsData *appPrefs;
	GBPrefsData *prefs;
}

@property (assign) id prefsDelegate;
@property (retain) GBAppPrefsData *appPrefs;
@property (retain) GBPrefsData *prefs;

// To do any initial setup needed
- (void)performSetup:(id)prefsDel;

// To do any final cleanup needed
- (void)performShutDown;

// updating the info
- (void)update;

- (NSTabViewItem *)tab;

- (NSInteger)tag;

- (BOOL)hasChildren;
- (NSArray *)children;

- (GBPrefsTabController *)tcParent;

- (BOOL)isAppwide;


// Returns type of prefs this is as string
- (NSString *)type;

// Registering notification observers
- (void)registerNotificationObservers;

// Handling font manager
- (void)changeFont:(id)sender;

@end


// Prefs delegate must implement these methods
@interface NSObject (GBPrefsDelegate)
- (id)prefs;
- (id)appPrefs;
- (BOOL)isAppPrefs;
- (Class)prefsClassForController:(GBPrefsTabController *)c;
@end


